module EasyWeixin
	class Message
    include Response

		def initialize(to,from,time)
			@ToUserName = to
			@FromUserName = from
			@CreateTime = time
		end

	end

	class ReplyMessage
		include ROXML
		xml_name :xml

		xml_accessor :ToUserName, :cdata => true
    xml_accessor :FromUserName, :cdata => true
    xml_reader :CreateTime, :as => Integer
    xml_reader :MsgType, :cdata => true
    xml_accessor :MsgId, :cdata => true


    def initialize
			@CreateTime = Time.now.to_i
		end

		def to_xml
      super.to_xml(:encoding => 'UTF-8', :indent => 0, :save_with => 0)
    end

	end

	class TextReplyMessage < ReplyMessage
    xml_accessor :Content, :cdata => true

    def initialize
      super
      @MsgType = 'text'
    end
  end

  class Item
    include ROXML

    xml_accessor :Title, :cdata => true
    xml_accessor :Description, :cdata => true
    xml_accessor :PicUrl, :cdata => true
    xml_accessor :Url, :cdata => true
	end

  class NewsReplyMessage < ReplyMessage
		xml_accessor :ArticleCount, :as => Integer
    xml_accessor :Articles, :as => [Item], :in => 'Articles', :from => 'item'

    def initialize
    	super
			@MsgType = 'news'
		end

  end


end
